﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	public class MyMatrix {
		private var ar:Array;
		private var width:int;
		private var height:int;
		public function MyMatrix():void {
			ar=new Array();
		}
		
		public function getWidth():int {
			return width;
		}
		
		public function getHeight():int {
			return height;
		}
		
		public function setObject(x:int,y:int,o:Object):Boolean {
			if (ar[y]==null) ar[y]=new Array();
			var old:Object = ar[y][x];
			ar[y][x] = o;
			if (x+1>width) width=x+1;
			if (y+1>height) height=y+1;
			return (old!=null);
		}
		
		public function getObject(x:int,y:int):Object {
			var line:Array = ar[y];
			if (line==null) return null;
			return line[x];
		}
		
		public function cleanUp() {
			// eliminate empty cols form the left
			trace("cleaning up");
			while (colIsEmpty(0)) {
				trace("first col is empty");
				removeFirstCol();
				width--;
			}
			// eliminate empty rows from the top
			while (rowIsEmpty(0)) {
				trace("first row is empty");
				ar.shift();
				height--;
			}
		}
		
		public function removeFirstCol() {
			for (var y:int=0;y<getHeight();y++) {
				if (ar[y]!=null) ar[y].shift();
			}
		}
		
		private function colIsEmpty(x:int) {
			for (var y:int=0;y<getHeight();y++) {
				if (getObject(x,y)!=null) return false;
			}
			return true;
		}

		private function rowIsEmpty(y:int) {
			for (var x:int=0;x<getWidth();x++) {
				if (getObject(x,y)!=null) return false;
			}
			return true;
		}
	}
}