﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	import flash.geom.ColorTransform;
	public class Particle extends MovieClip {
		private const GRAVITY:Number = 0.9;
		var dx:Number;
		var dy:Number;
		private  var colorT:ColorTransform;
		var dRot:Number;
		var ticks:int;
		public function Particle(startX:Number, startY:Number,color:int):void {
			x=startX;
			y=startY;
			dx= -10+Math.random()*20;
			dy=-5*Math.random();
			dRot = -5+Math.random()*10;
			ticks=0;
			// select one random debris
			gotoAndStop(Math.floor(Math.random()*4)+1);
			// set the color
			colorT= new ColorTransform(0,0,0,1,(color&0xFF0000)>>16,(color&0x00FF00)>>8,(color&0x0000FF),0);
			transform.colorTransform=colorT;
		}
		
		public function animate():void {
			dy+=GRAVITY;
			rotation+=dRot;
			x+=dx;
			y+=dy;
			ticks++;
			alpha-=.01;
		}
		
		public function isAlive():Boolean {
			return alpha>0;
		}
		
	}
}